// Code generated by SQLBoiler (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package postgres

import (
	"context"
	"database/sql"
	"fmt"
	"reflect"
	"strconv"
	"strings"
	"sync"
	"time"

	"github.com/pkg/errors"
	"github.com/volatiletech/sqlboiler/boil"
	"github.com/volatiletech/sqlboiler/queries"
	"github.com/volatiletech/sqlboiler/queries/qm"
	"github.com/volatiletech/sqlboiler/queries/qmhelper"
	"github.com/volatiletech/sqlboiler/strmangle"
	"github.com/volatiletech/sqlboiler/types"
)

// Transport is an object representing the database table.
type Transport struct {
	ID       int64         `boil:"id" json:"id" toml:"id" yaml:"id"`
	DriverID int64         `boil:"driver_id" json:"driver_id" toml:"driver_id" yaml:"driver_id"`
	Name     string        `boil:"name" json:"name" toml:"name" yaml:"name"`
	Tariff   int64         `boil:"tariff" json:"tariff" toml:"tariff" yaml:"tariff"`
	Cost     int64         `boil:"cost" json:"cost" toml:"cost" yaml:"cost"`
	Carryng  types.Decimal `boil:"carryng" json:"carryng" toml:"carryng" yaml:"carryng"`

	R *transportR `boil:"-" json:"-" toml:"-" yaml:"-"`
	L transportL  `boil:"-" json:"-" toml:"-" yaml:"-"`
}

var TransportColumns = struct {
	ID       string
	DriverID string
	Name     string
	Tariff   string
	Cost     string
	Carryng  string
}{
	ID:       "id",
	DriverID: "driver_id",
	Name:     "name",
	Tariff:   "tariff",
	Cost:     "cost",
	Carryng:  "carryng",
}

// Generated where

var TransportWhere = struct {
	ID       whereHelperint64
	DriverID whereHelperint64
	Name     whereHelperstring
	Tariff   whereHelperint64
	Cost     whereHelperint64
	Carryng  whereHelpertypes_Decimal
}{
	ID:       whereHelperint64{field: "\"transport\".\"id\""},
	DriverID: whereHelperint64{field: "\"transport\".\"driver_id\""},
	Name:     whereHelperstring{field: "\"transport\".\"name\""},
	Tariff:   whereHelperint64{field: "\"transport\".\"tariff\""},
	Cost:     whereHelperint64{field: "\"transport\".\"cost\""},
	Carryng:  whereHelpertypes_Decimal{field: "\"transport\".\"carryng\""},
}

// TransportRels is where relationship names are stored.
var TransportRels = struct {
	Driver string
}{
	Driver: "Driver",
}

// transportR is where relationships are stored.
type transportR struct {
	Driver *Driver
}

// NewStruct creates a new relationship struct
func (*transportR) NewStruct() *transportR {
	return &transportR{}
}

// transportL is where Load methods for each relationship are stored.
type transportL struct{}

var (
	transportColumns               = []string{"id", "driver_id", "name", "tariff", "cost", "carryng"}
	transportColumnsWithoutDefault = []string{"driver_id", "name", "tariff", "cost", "carryng"}
	transportColumnsWithDefault    = []string{"id"}
	transportPrimaryKeyColumns     = []string{"id"}
)

type (
	// TransportSlice is an alias for a slice of pointers to Transport.
	// This should generally be used opposed to []Transport.
	TransportSlice []*Transport
	// TransportHook is the signature for custom Transport hook methods
	TransportHook func(context.Context, boil.ContextExecutor, *Transport) error

	transportQuery struct {
		*queries.Query
	}
)

// Cache for insert, update and upsert
var (
	transportType                 = reflect.TypeOf(&Transport{})
	transportMapping              = queries.MakeStructMapping(transportType)
	transportPrimaryKeyMapping, _ = queries.BindMapping(transportType, transportMapping, transportPrimaryKeyColumns)
	transportInsertCacheMut       sync.RWMutex
	transportInsertCache          = make(map[string]insertCache)
	transportUpdateCacheMut       sync.RWMutex
	transportUpdateCache          = make(map[string]updateCache)
	transportUpsertCacheMut       sync.RWMutex
	transportUpsertCache          = make(map[string]insertCache)
)

var (
	// Force time package dependency for automated UpdatedAt/CreatedAt.
	_ = time.Second
	// Force qmhelper dependency for where clause generation (which doesn't
	// always happen)
	_ = qmhelper.Where
)

var transportBeforeInsertHooks []TransportHook
var transportBeforeUpdateHooks []TransportHook
var transportBeforeDeleteHooks []TransportHook
var transportBeforeUpsertHooks []TransportHook

var transportAfterInsertHooks []TransportHook
var transportAfterSelectHooks []TransportHook
var transportAfterUpdateHooks []TransportHook
var transportAfterDeleteHooks []TransportHook
var transportAfterUpsertHooks []TransportHook

// doBeforeInsertHooks executes all "before insert" hooks.
func (o *Transport) doBeforeInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range transportBeforeInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpdateHooks executes all "before Update" hooks.
func (o *Transport) doBeforeUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range transportBeforeUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeDeleteHooks executes all "before Delete" hooks.
func (o *Transport) doBeforeDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range transportBeforeDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpsertHooks executes all "before Upsert" hooks.
func (o *Transport) doBeforeUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range transportBeforeUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterInsertHooks executes all "after Insert" hooks.
func (o *Transport) doAfterInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range transportAfterInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterSelectHooks executes all "after Select" hooks.
func (o *Transport) doAfterSelectHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range transportAfterSelectHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpdateHooks executes all "after Update" hooks.
func (o *Transport) doAfterUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range transportAfterUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterDeleteHooks executes all "after Delete" hooks.
func (o *Transport) doAfterDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range transportAfterDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpsertHooks executes all "after Upsert" hooks.
func (o *Transport) doAfterUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range transportAfterUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// AddTransportHook registers your hook function for all future operations.
func AddTransportHook(hookPoint boil.HookPoint, transportHook TransportHook) {
	switch hookPoint {
	case boil.BeforeInsertHook:
		transportBeforeInsertHooks = append(transportBeforeInsertHooks, transportHook)
	case boil.BeforeUpdateHook:
		transportBeforeUpdateHooks = append(transportBeforeUpdateHooks, transportHook)
	case boil.BeforeDeleteHook:
		transportBeforeDeleteHooks = append(transportBeforeDeleteHooks, transportHook)
	case boil.BeforeUpsertHook:
		transportBeforeUpsertHooks = append(transportBeforeUpsertHooks, transportHook)
	case boil.AfterInsertHook:
		transportAfterInsertHooks = append(transportAfterInsertHooks, transportHook)
	case boil.AfterSelectHook:
		transportAfterSelectHooks = append(transportAfterSelectHooks, transportHook)
	case boil.AfterUpdateHook:
		transportAfterUpdateHooks = append(transportAfterUpdateHooks, transportHook)
	case boil.AfterDeleteHook:
		transportAfterDeleteHooks = append(transportAfterDeleteHooks, transportHook)
	case boil.AfterUpsertHook:
		transportAfterUpsertHooks = append(transportAfterUpsertHooks, transportHook)
	}
}

// One returns a single transport record from the query.
func (q transportQuery) One(ctx context.Context, exec boil.ContextExecutor) (*Transport, error) {
	o := &Transport{}

	queries.SetLimit(q.Query, 1)

	err := q.Bind(ctx, exec, o)
	if err != nil {
		if errors.Cause(err) == sql.ErrNoRows {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "postgres: failed to execute a one query for transport")
	}

	if err := o.doAfterSelectHooks(ctx, exec); err != nil {
		return o, err
	}

	return o, nil
}

// All returns all Transport records from the query.
func (q transportQuery) All(ctx context.Context, exec boil.ContextExecutor) (TransportSlice, error) {
	var o []*Transport

	err := q.Bind(ctx, exec, &o)
	if err != nil {
		return nil, errors.Wrap(err, "postgres: failed to assign all query results to Transport slice")
	}

	if len(transportAfterSelectHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterSelectHooks(ctx, exec); err != nil {
				return o, err
			}
		}
	}

	return o, nil
}

// Count returns the count of all Transport records in the query.
func (q transportQuery) Count(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: failed to count transport rows")
	}

	return count, nil
}

// Exists checks if the row exists in the table.
func (q transportQuery) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)
	queries.SetLimit(q.Query, 1)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return false, errors.Wrap(err, "postgres: failed to check if transport exists")
	}

	return count > 0, nil
}

// Driver pointed to by the foreign key.
func (o *Transport) Driver(mods ...qm.QueryMod) driverQuery {
	queryMods := []qm.QueryMod{
		qm.Where("id=?", o.DriverID),
	}

	queryMods = append(queryMods, mods...)

	query := Drivers(queryMods...)
	queries.SetFrom(query.Query, "\"driver\"")

	return query
}

// LoadDriver allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for an N-1 relationship.
func (transportL) LoadDriver(ctx context.Context, e boil.ContextExecutor, singular bool, maybeTransport interface{}, mods queries.Applicator) error {
	var slice []*Transport
	var object *Transport

	if singular {
		object = maybeTransport.(*Transport)
	} else {
		slice = *maybeTransport.(*[]*Transport)
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &transportR{}
		}
		args = append(args, object.DriverID)

	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &transportR{}
			}

			for _, a := range args {
				if a == obj.DriverID {
					continue Outer
				}
			}

			args = append(args, obj.DriverID)

		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(qm.From(`driver`), qm.WhereIn(`id in ?`, args...))
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load Driver")
	}

	var resultSlice []*Driver
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice Driver")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results of eager load for driver")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for driver")
	}

	if len(transportAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}

	if len(resultSlice) == 0 {
		return nil
	}

	if singular {
		foreign := resultSlice[0]
		object.R.Driver = foreign
		if foreign.R == nil {
			foreign.R = &driverR{}
		}
		foreign.R.Transports = append(foreign.R.Transports, object)
		return nil
	}

	for _, local := range slice {
		for _, foreign := range resultSlice {
			if local.DriverID == foreign.ID {
				local.R.Driver = foreign
				if foreign.R == nil {
					foreign.R = &driverR{}
				}
				foreign.R.Transports = append(foreign.R.Transports, local)
				break
			}
		}
	}

	return nil
}

// SetDriver of the transport to the related item.
// Sets o.R.Driver to related.
// Adds o to related.R.Transports.
func (o *Transport) SetDriver(ctx context.Context, exec boil.ContextExecutor, insert bool, related *Driver) error {
	var err error
	if insert {
		if err = related.Insert(ctx, exec, boil.Infer()); err != nil {
			return errors.Wrap(err, "failed to insert into foreign table")
		}
	}

	updateQuery := fmt.Sprintf(
		"UPDATE \"transport\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, []string{"driver_id"}),
		strmangle.WhereClause("\"", "\"", 2, transportPrimaryKeyColumns),
	)
	values := []interface{}{related.ID, o.ID}

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, updateQuery)
		fmt.Fprintln(boil.DebugWriter, values)
	}

	if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	o.DriverID = related.ID
	if o.R == nil {
		o.R = &transportR{
			Driver: related,
		}
	} else {
		o.R.Driver = related
	}

	if related.R == nil {
		related.R = &driverR{
			Transports: TransportSlice{o},
		}
	} else {
		related.R.Transports = append(related.R.Transports, o)
	}

	return nil
}

// Transports retrieves all the records using an executor.
func Transports(mods ...qm.QueryMod) transportQuery {
	mods = append(mods, qm.From("\"transport\""))
	return transportQuery{NewQuery(mods...)}
}

// FindTransport retrieves a single record by ID with an executor.
// If selectCols is empty Find will return all columns.
func FindTransport(ctx context.Context, exec boil.ContextExecutor, iD int64, selectCols ...string) (*Transport, error) {
	transportObj := &Transport{}

	sel := "*"
	if len(selectCols) > 0 {
		sel = strings.Join(strmangle.IdentQuoteSlice(dialect.LQ, dialect.RQ, selectCols), ",")
	}
	query := fmt.Sprintf(
		"select %s from \"transport\" where \"id\"=$1", sel,
	)

	q := queries.Raw(query, iD)

	err := q.Bind(ctx, exec, transportObj)
	if err != nil {
		if errors.Cause(err) == sql.ErrNoRows {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "postgres: unable to select from transport")
	}

	return transportObj, nil
}

// Insert a single record using an executor.
// See boil.Columns.InsertColumnSet documentation to understand column list inference for inserts.
func (o *Transport) Insert(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) error {
	if o == nil {
		return errors.New("postgres: no transport provided for insertion")
	}

	var err error

	if err := o.doBeforeInsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(transportColumnsWithDefault, o)

	key := makeCacheKey(columns, nzDefaults)
	transportInsertCacheMut.RLock()
	cache, cached := transportInsertCache[key]
	transportInsertCacheMut.RUnlock()

	if !cached {
		wl, returnColumns := columns.InsertColumnSet(
			transportColumns,
			transportColumnsWithDefault,
			transportColumnsWithoutDefault,
			nzDefaults,
		)

		cache.valueMapping, err = queries.BindMapping(transportType, transportMapping, wl)
		if err != nil {
			return err
		}
		cache.retMapping, err = queries.BindMapping(transportType, transportMapping, returnColumns)
		if err != nil {
			return err
		}
		if len(wl) != 0 {
			cache.query = fmt.Sprintf("INSERT INTO \"transport\" (\"%s\") %%sVALUES (%s)%%s", strings.Join(wl, "\",\""), strmangle.Placeholders(dialect.UseIndexPlaceholders, len(wl), 1, 1))
		} else {
			cache.query = "INSERT INTO \"transport\" %sDEFAULT VALUES%s"
		}

		var queryOutput, queryReturning string

		if len(cache.retMapping) != 0 {
			queryReturning = fmt.Sprintf(" RETURNING \"%s\"", strings.Join(returnColumns, "\",\""))
		}

		cache.query = fmt.Sprintf(cache.query, queryOutput, queryReturning)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, cache.query)
		fmt.Fprintln(boil.DebugWriter, vals)
	}

	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(queries.PtrsFromMapping(value, cache.retMapping)...)
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}

	if err != nil {
		return errors.Wrap(err, "postgres: unable to insert into transport")
	}

	if !cached {
		transportInsertCacheMut.Lock()
		transportInsertCache[key] = cache
		transportInsertCacheMut.Unlock()
	}

	return o.doAfterInsertHooks(ctx, exec)
}

// Update uses an executor to update the Transport.
// See boil.Columns.UpdateColumnSet documentation to understand column list inference for updates.
// Update does not automatically update the record in case of default values. Use .Reload() to refresh the records.
func (o *Transport) Update(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) (int64, error) {
	var err error
	if err = o.doBeforeUpdateHooks(ctx, exec); err != nil {
		return 0, err
	}
	key := makeCacheKey(columns, nil)
	transportUpdateCacheMut.RLock()
	cache, cached := transportUpdateCache[key]
	transportUpdateCacheMut.RUnlock()

	if !cached {
		wl := columns.UpdateColumnSet(
			transportColumns,
			transportPrimaryKeyColumns,
		)

		if !columns.IsWhitelist() {
			wl = strmangle.SetComplement(wl, []string{"created_at"})
		}
		if len(wl) == 0 {
			return 0, errors.New("postgres: unable to update transport, could not build whitelist")
		}

		cache.query = fmt.Sprintf("UPDATE \"transport\" SET %s WHERE %s",
			strmangle.SetParamNames("\"", "\"", 1, wl),
			strmangle.WhereClause("\"", "\"", len(wl)+1, transportPrimaryKeyColumns),
		)
		cache.valueMapping, err = queries.BindMapping(transportType, transportMapping, append(wl, transportPrimaryKeyColumns...))
		if err != nil {
			return 0, err
		}
	}

	values := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), cache.valueMapping)

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, cache.query)
		fmt.Fprintln(boil.DebugWriter, values)
	}

	var result sql.Result
	result, err = exec.ExecContext(ctx, cache.query, values...)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to update transport row")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: failed to get rows affected by update for transport")
	}

	if !cached {
		transportUpdateCacheMut.Lock()
		transportUpdateCache[key] = cache
		transportUpdateCacheMut.Unlock()
	}

	return rowsAff, o.doAfterUpdateHooks(ctx, exec)
}

// UpdateAll updates all rows with the specified column values.
func (q transportQuery) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	queries.SetUpdate(q.Query, cols)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to update all for transport")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to retrieve rows affected for transport")
	}

	return rowsAff, nil
}

// UpdateAll updates all rows with the specified column values, using an executor.
func (o TransportSlice) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	ln := int64(len(o))
	if ln == 0 {
		return 0, nil
	}

	if len(cols) == 0 {
		return 0, errors.New("postgres: update all requires at least one column argument")
	}

	colNames := make([]string, len(cols))
	args := make([]interface{}, len(cols))

	i := 0
	for name, value := range cols {
		colNames[i] = name
		args[i] = value
		i++
	}

	// Append all of the primary key values for each column
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), transportPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := fmt.Sprintf("UPDATE \"transport\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, colNames),
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), len(colNames)+1, transportPrimaryKeyColumns, len(o)))

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, sql)
		fmt.Fprintln(boil.DebugWriter, args...)
	}

	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to update all in transport slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to retrieve rows affected all in update all transport")
	}
	return rowsAff, nil
}

// Upsert attempts an insert using an executor, and does an update or ignore on conflict.
// See boil.Columns documentation for how to properly use updateColumns and insertColumns.
func (o *Transport) Upsert(ctx context.Context, exec boil.ContextExecutor, updateOnConflict bool, conflictColumns []string, updateColumns, insertColumns boil.Columns) error {
	if o == nil {
		return errors.New("postgres: no transport provided for upsert")
	}

	if err := o.doBeforeUpsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(transportColumnsWithDefault, o)

	// Build cache key in-line uglily - mysql vs psql problems
	buf := strmangle.GetBuffer()
	if updateOnConflict {
		buf.WriteByte('t')
	} else {
		buf.WriteByte('f')
	}
	buf.WriteByte('.')
	for _, c := range conflictColumns {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(updateColumns.Kind))
	for _, c := range updateColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(insertColumns.Kind))
	for _, c := range insertColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	for _, c := range nzDefaults {
		buf.WriteString(c)
	}
	key := buf.String()
	strmangle.PutBuffer(buf)

	transportUpsertCacheMut.RLock()
	cache, cached := transportUpsertCache[key]
	transportUpsertCacheMut.RUnlock()

	var err error

	if !cached {
		insert, ret := insertColumns.InsertColumnSet(
			transportColumns,
			transportColumnsWithDefault,
			transportColumnsWithoutDefault,
			nzDefaults,
		)
		update := updateColumns.UpdateColumnSet(
			transportColumns,
			transportPrimaryKeyColumns,
		)

		if len(update) == 0 {
			return errors.New("postgres: unable to upsert transport, could not build update column list")
		}

		conflict := conflictColumns
		if len(conflict) == 0 {
			conflict = make([]string, len(transportPrimaryKeyColumns))
			copy(conflict, transportPrimaryKeyColumns)
		}
		cache.query = buildUpsertQueryPostgres(dialect, "\"transport\"", updateOnConflict, ret, update, conflict, insert)

		cache.valueMapping, err = queries.BindMapping(transportType, transportMapping, insert)
		if err != nil {
			return err
		}
		if len(ret) != 0 {
			cache.retMapping, err = queries.BindMapping(transportType, transportMapping, ret)
			if err != nil {
				return err
			}
		}
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)
	var returns []interface{}
	if len(cache.retMapping) != 0 {
		returns = queries.PtrsFromMapping(value, cache.retMapping)
	}

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, cache.query)
		fmt.Fprintln(boil.DebugWriter, vals)
	}

	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(returns...)
		if err == sql.ErrNoRows {
			err = nil // Postgres doesn't return anything when there's no update
		}
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}
	if err != nil {
		return errors.Wrap(err, "postgres: unable to upsert transport")
	}

	if !cached {
		transportUpsertCacheMut.Lock()
		transportUpsertCache[key] = cache
		transportUpsertCacheMut.Unlock()
	}

	return o.doAfterUpsertHooks(ctx, exec)
}

// Delete deletes a single Transport record with an executor.
// Delete will match against the primary key column to find the record to delete.
func (o *Transport) Delete(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if o == nil {
		return 0, errors.New("postgres: no Transport provided for delete")
	}

	if err := o.doBeforeDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	args := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), transportPrimaryKeyMapping)
	sql := "DELETE FROM \"transport\" WHERE \"id\"=$1"

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, sql)
		fmt.Fprintln(boil.DebugWriter, args...)
	}

	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to delete from transport")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: failed to get rows affected by delete for transport")
	}

	if err := o.doAfterDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	return rowsAff, nil
}

// DeleteAll deletes all matching rows.
func (q transportQuery) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if q.Query == nil {
		return 0, errors.New("postgres: no transportQuery provided for delete all")
	}

	queries.SetDelete(q.Query)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to delete all from transport")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: failed to get rows affected by deleteall for transport")
	}

	return rowsAff, nil
}

// DeleteAll deletes all rows in the slice, using an executor.
func (o TransportSlice) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if len(o) == 0 {
		return 0, nil
	}

	if len(transportBeforeDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doBeforeDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	var args []interface{}
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), transportPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "DELETE FROM \"transport\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, transportPrimaryKeyColumns, len(o))

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, sql)
		fmt.Fprintln(boil.DebugWriter, args)
	}

	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to delete all from transport slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: failed to get rows affected by deleteall for transport")
	}

	if len(transportAfterDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	return rowsAff, nil
}

// Reload refetches the object from the database
// using the primary keys with an executor.
func (o *Transport) Reload(ctx context.Context, exec boil.ContextExecutor) error {
	ret, err := FindTransport(ctx, exec, o.ID)
	if err != nil {
		return err
	}

	*o = *ret
	return nil
}

// ReloadAll refetches every row with matching primary key column values
// and overwrites the original object slice with the newly updated slice.
func (o *TransportSlice) ReloadAll(ctx context.Context, exec boil.ContextExecutor) error {
	if o == nil || len(*o) == 0 {
		return nil
	}

	slice := TransportSlice{}
	var args []interface{}
	for _, obj := range *o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), transportPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "SELECT \"transport\".* FROM \"transport\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, transportPrimaryKeyColumns, len(*o))

	q := queries.Raw(sql, args...)

	err := q.Bind(ctx, exec, &slice)
	if err != nil {
		return errors.Wrap(err, "postgres: unable to reload all in TransportSlice")
	}

	*o = slice

	return nil
}

// TransportExists checks if the Transport row exists.
func TransportExists(ctx context.Context, exec boil.ContextExecutor, iD int64) (bool, error) {
	var exists bool
	sql := "select exists(select 1 from \"transport\" where \"id\"=$1 limit 1)"

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, sql)
		fmt.Fprintln(boil.DebugWriter, iD)
	}

	row := exec.QueryRowContext(ctx, sql, iD)

	err := row.Scan(&exists)
	if err != nil {
		return false, errors.Wrap(err, "postgres: unable to check if transport exists")
	}

	return exists, nil
}
